
<!DOCTYPE html>

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta charset="utf-8" />
    <title>controller.config module &#8212; DataMAx 0.1 documentation</title>
    <link rel="stylesheet" href="_static/nature.css" type="text/css" />
    <link rel="stylesheet" href="_static/pygments.css" type="text/css" />
    <script type="text/javascript" id="documentation_options" data-url_root="./" src="_static/documentation_options.js"></script>
    <script type="text/javascript" src="_static/jquery.js"></script>
    <script type="text/javascript" src="_static/underscore.js"></script>
    <script type="text/javascript" src="_static/doctools.js"></script>
    <script type="text/javascript" src="_static/language_data.js"></script>
    <link rel="index" title="Index" href="genindex.html" />
    <link rel="search" title="Search" href="search.html" /> 
  </head><body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="nav-item nav-item-0"><a href="index.html">DataMAx 0.1 documentation</a> &#187;</li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="module-controller.config">
<span id="controller-config-module"></span><h1>controller.config module<a class="headerlink" href="#module-controller.config" title="Permalink to this headline">¶</a></h1>
<p>Configuration module for the validation engine.</p>
<div class="admonition seealso">
<p class="admonition-title">See also</p>
<p><a class="reference internal" href="controller.project.html#module-controller.project" title="controller.project"><code class="xref py py-func docutils literal notranslate"><span class="pre">project()</span></code></a> To manage projects to which config belongs.</p>
</div>
<dl class="function">
<dt id="controller.config.index">
<code class="sig-prename descclassname">controller.config.</code><code class="sig-name descname">index</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#controller.config.index" title="Permalink to this definition">¶</a></dt>
<dd><p>Fetch the latest configs from the postgres db.</p>
<dl class="field-list simple">
<dt class="field-odd">Returns</dt>
<dd class="field-odd"><p>a JSON object</p>
</dd>
<dt class="field-even">Return type</dt>
<dd class="field-even"><p>dict</p>
</dd>
</dl>
<p class="rubric">Examples</p>
<p>Get a few configs from the postgres db.</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="kn">import</span> <span class="nn">requests</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">requests</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;http://localhost:5001/api/config/&#39;</span><span class="p">)</span>
<span class="go">configs: [{</span>
<span class="go">      &quot;created_by&quot;: null,</span>
<span class="go">      &quot;creation_date&quot;: &quot;Thu, 20 Jun 2019 07:34:17 GMT&quot;,</span>
<span class="go">      &quot;file_id&quot;: null,</span>
<span class="go">      &quot;id&quot;: 97,</span>
<span class="go">      &quot;is_active&quot;: true,</span>
<span class="go">      &quot;modification_date&quot;: &quot;Thu, 20 Jun 2019 07:34:17 GMT&quot;,</span>
<span class="go">      &quot;modified_by&quot;: null,</span>
<span class="go">      &quot;name&quot;: &quot;CT_All&quot;,</span>
<span class="go">      &quot;params&quot;: {</span>
<span class="go">        &quot;system_defined&quot;: [],</span>
<span class="go">        &quot;user_defined&quot;: []</span>
<span class="go">      },</span>
<span class="go">      &quot;std_object&quot;: &quot;Unknown&quot;,</span>
<span class="go">      &quot;version&quot;: 9</span>
<span class="go">    },</span>
<span class="go">    {</span>
<span class="go">      &quot;created_by&quot;: null,</span>
<span class="go">      &quot;creation_date&quot;: &quot;Thu, 20 Jun 2019 07:33:22 GMT&quot;,</span>
<span class="go">      &quot;file_id&quot;: null,</span>
<span class="go">      &quot;id&quot;: 96,</span>
<span class="go">      &quot;is_active&quot;: true,</span>
<span class="go">      &quot;modification_date&quot;: &quot;Thu, 20 Jun 2019 07:33:22 GMT&quot;,</span>
<span class="go">      &quot;modified_by&quot;: null,</span>
<span class="go">      &quot;name&quot;: &quot;Test_101&quot;,</span>
<span class="go">      &quot;params&quot;: {</span>
<span class="go">        &quot;system_defined&quot;: [</span>
<span class="go">          {</span>
<span class="go">            &quot;id&quot;: 9002,</span>
<span class="go">            &quot;parameters&quot;: [</span>
<span class="go">              {</span>
<span class="go">                &quot;datatype&quot;: &quot;any&quot;,</span>
<span class="go">                &quot;param&quot;: &quot;colname&quot;,</span>
<span class="go">                &quot;type&quot;: &quot;column&quot;,</span>
<span class="go">                &quot;value&quot;: &quot;id&quot;</span>
<span class="go">              },</span>
<span class="go">              {</span>
<span class="go">                &quot;param&quot;: &quot;tablename&quot;,</span>
<span class="go">                &quot;value&quot;: &quot;&quot;</span>
<span class="go">              },</span>
<span class="go">              {</span>
<span class="go">                &quot;param&quot;: &quot;schema&quot;,</span>
<span class="go">                &quot;type&quot;: &quot;schema&quot;,</span>
<span class="go">                &quot;value&quot;: &quot;&quot;</span>
<span class="go">              }</span>
<span class="go">            ]</span>
<span class="go">          }</span>
<span class="go">        ],</span>
<span class="go">        &quot;user_defined&quot;: [</span>
<span class="go">          {</span>
<span class="go">            &quot;id&quot;: &quot;1010&quot;,</span>
<span class="go">            &quot;parameters&quot;: [</span>
<span class="go">              {</span>
<span class="go">                &quot;param&quot;: &quot;colname&quot;,</span>
<span class="go">                &quot;value&quot;: &quot;hex&quot;</span>
<span class="go">              },</span>
<span class="go">              {</span>
<span class="go">                &quot;param&quot;: &quot;operator&quot;,</span>
<span class="go">                &quot;value&quot;: &quot;&lt;&quot;</span>
<span class="go">              },</span>
<span class="go">              {</span>
<span class="go">                &quot;param&quot;: &quot;thresholdval&quot;,</span>
<span class="go">                &quot;value&quot;: &quot;4&quot;</span>
<span class="go">              }</span>
<span class="go">            ]</span>
<span class="go">          }]</span>
</pre></div>
</div>
</dd></dl>

<dl class="function">
<dt id="controller.config.add">
<code class="sig-prename descclassname">controller.config.</code><code class="sig-name descname">add</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#controller.config.add" title="Permalink to this definition">¶</a></dt>
<dd><p>Add configuration into the postgres db for a given file.</p>
<p>Save the configuration in <code class="docutils literal notranslate"><span class="pre">config</span></code> table of the postgres db and generate a unique ID which will be used by
other services to retrieve the configuration required to run the validation. The API support both GET and POST
protocol.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>file_id</strong> (<em>int</em>) – file id</p></li>
<li><p><strong>project_id</strong> (<em>int</em>) – project reference to which the config belongs</p></li>
<li><p><strong>name</strong> (<em>string</em>) – Identifier for the unique configuration which share different versions</p></li>
<li><p><strong>std_object</strong> (<em>string</em>) – [Optional] mapping of the current config to any specific standard object</p></li>
<li><p><strong>user_defined</strong> (<em>JSON</em>) – [Optional] the configuration required to run the validations.</p></li>
<li><p><strong>system_defined</strong> (<em>JSON</em>) – [Optional] these include the data type checks.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>a JSON object which has the <code class="docutils literal notranslate"><span class="pre">config_id</span></code> generated for the given configuration.</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p>dict</p>
</dd>
</dl>
<p class="rubric">Examples</p>
<p>Add configuration against the standard object.</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="kn">import</span> <span class="nn">requests</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">requests</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;http://localhost:5001/api/config/add?project=DEFAULT&amp;user_defined=&#39;</span>
<span class="gp">... </span>             <span class="s1">&#39;[{ &quot;parameters&quot;: [ { &quot;param&quot;: &quot;colname&quot;, &quot;value&quot;: &quot;NRX_AMOUNT&quot; }, { &quot;param&quot;:&#39;</span>
<span class="gp">... </span>             <span class="s1">&#39;&quot;tablename&quot;, &quot;value&quot;: &quot;s3__121_1212&quot; } ], &quot;description&quot;: &quot;Check if all values in&#39;</span>
<span class="gp">... </span>             <span class="s1">&#39;column are of float data type&quot;, &quot;id&quot;: 1004, &quot;name&quot;: &quot;CheckFloatDataType&quot; }]&amp;&#39;</span>
<span class="gp">... </span>             <span class="s1">&#39;std_object=unknown&amp;name=dummy retail sales&amp;project_id=12&#39;</span><span class="p">)</span>
<span class="go">{</span>
<span class="go">    &quot;config&quot;: [</span>
<span class="go">        {</span>
<span class="go">            &quot;created_by&quot;: null,</span>
<span class="go">            &quot;creation_date&quot;: &quot;Mon, 27 May 2019 09:46:12 GMT&quot;,</span>
<span class="go">            &quot;id&quot;: 27,</span>
<span class="go">            &quot;is_active&quot;: true,</span>
<span class="go">            &quot;modification_date&quot;: &quot;Mon, 27 May 2019 09:46:12 GMT&quot;,</span>
<span class="go">            &quot;modified_by&quot;: null,</span>
<span class="go">            &quot;name&quot;: &quot;dummy retail sales&quot;,</span>
<span class="go">            &quot;params&quot;: [</span>
<span class="go">                {</span>
<span class="go">                    &quot;datatype&quot;: &quot;varchar&quot;,</span>
<span class="go">                    &quot;id&quot;: 1009,</span>
<span class="go">                    &quot;name&quot;: &quot;CheckColumnLength&quot;,</span>
<span class="go">                    &quot;parameters&quot;: [</span>
<span class="go">                        {</span>
<span class="go">                            &quot;param&quot;: &quot;tablename&quot;,</span>
<span class="go">                            &quot;value&quot;: &quot;s3_e8f3658a7d6c40eeb2efc2076d969d3a&quot;</span>
<span class="go">                        },</span>
<span class="go">                        {</span>
<span class="go">                            &quot;datatype&quot;: &quot;varchar&quot;,</span>
<span class="go">                            &quot;param&quot;: &quot;colname&quot;,</span>
<span class="go">                            &quot;type&quot;: &quot;column&quot;,</span>
<span class="go">                            &quot;value&quot;: &quot;market_id&quot;</span>
<span class="go">                        },</span>
<span class="go">                        {</span>
<span class="go">                            &quot;param&quot;: &quot;operator&quot;,</span>
<span class="go">                            &quot;value&quot;: &quot;=&quot;</span>
<span class="go">                        },</span>
<span class="go">                        {</span>
<span class="go">                            &quot;param&quot;: &quot;thresholdval&quot;,</span>
<span class="go">                            &quot;value&quot;: &quot;6&quot;</span>
<span class="go">                        },</span>
<span class="go">                        {</span>
<span class="go">                            &quot;param&quot;: &quot;schema&quot;,</span>
<span class="go">                            &quot;type&quot;: &quot;schema&quot;,</span>
<span class="go">                            &quot;value&quot;: &quot;source&quot;</span>
<span class="go">                        }</span>
<span class="go">                    ]</span>
<span class="go">                },</span>
<span class="go">                {</span>
<span class="go">                    ...</span>
<span class="go">                }</span>
<span class="go">            ],</span>
<span class="go">            &quot;std_object&quot;: &quot;unknown&quot;,</span>
<span class="go">            &quot;version&quot;: 1</span>
<span class="go">        }</span>
<span class="go">    ]</span>
<span class="go">}</span>
</pre></div>
</div>
</dd></dl>

<dl class="function">
<dt id="controller.config.search">
<code class="sig-prename descclassname">controller.config.</code><code class="sig-name descname">search</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#controller.config.search" title="Permalink to this definition">¶</a></dt>
<dd><p>Retrieve the configuration from the postgres db.</p>
<p>Fetch the configurations from postgres for a given standard object.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>name</strong> (<em>string</em>) – [Optional] filter result on pattern given on user defined name.</p></li>
<li><p><strong>version</strong> (<em>int</em>) – [Optional] the version of the config to be fetched</p></li>
<li><p><strong>std_object</strong> (<em>string</em>) – [Optional] standard object for which the configuration has to be fetched.</p></li>
<li><p><strong>connector_id</strong> (<em>int</em>) – [Optional] connection id for the resource.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>a JSON object with all the filled <code class="docutils literal notranslate"><span class="pre">parameters</span></code>.</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p>dict</p>
</dd>
</dl>
<p class="rubric">Examples</p>
<p>Search for all the versions of <cite>config</cite> of the standard object.</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="kn">import</span> <span class="nn">requests</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">requests</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;http://localhost:5001/api/config/search?&#39;</span>
<span class="gp">... </span>             <span class="s1">&#39;std_object=SHS.Retail Sales&#39;</span><span class="p">)</span>
<span class="go">{</span>
<span class="go">  &quot;configs&quot;: [</span>
<span class="go">    {</span>
<span class="go">      &quot;created_by&quot;: null,</span>
<span class="go">      &quot;creation_date&quot;: &quot;Tue, 14 May 2019 17:05:43 GMT&quot;,</span>
<span class="go">      &quot;id&quot;: 1,</span>
<span class="go">      &quot;is_active&quot;: true,</span>
<span class="go">      &quot;modification_date&quot;: &quot;Tue, 14 May 2019 17:05:43 GMT&quot;,</span>
<span class="go">      &quot;modified_by&quot;: null,</span>
<span class="go">      &quot;name&quot;: &quot;symphony sales config&quot;,</span>
<span class="go">      &quot;params&quot;: [</span>
<span class="go">        {</span>
<span class="go">          &quot;description&quot;: &quot;Check if all values in column are of float data type&quot;,</span>
<span class="go">          &quot;id&quot;: 1004,</span>
<span class="go">          &quot;name&quot;: &quot;CheckFloatDataType&quot;,</span>
<span class="go">          &quot;parameters&quot;: [</span>
<span class="go">            {</span>
<span class="go">              &quot;param&quot;: &quot;colname&quot;,</span>
<span class="go">              &quot;value&quot;: &quot;NRX_AMOUNT&quot;</span>
<span class="go">            },</span>
<span class="go">            {</span>
<span class="go">              &quot;param&quot;: &quot;tablename&quot;,</span>
<span class="go">              &quot;value&quot;: &quot;s3__121_1212&quot;</span>
<span class="go">            }</span>
<span class="go">          ]</span>
<span class="go">        }</span>
<span class="go">      ],</span>
<span class="go">      &quot;std_object&quot;: &quot;SHS.Retail Sales&quot;,</span>
<span class="go">      &quot;version&quot;: 1</span>
<span class="go">    }</span>
<span class="go">  ]</span>
<span class="go">}</span>
</pre></div>
</div>
<p>Search by providing incomplete name in the parameter.</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="kn">import</span> <span class="nn">requests</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">requests</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;http://localhost:5001/api/config/search?&#39;</span>
<span class="gp">... </span>             <span class="s1">&#39;name=sales&#39;</span><span class="p">)</span>
<span class="go">{</span>
<span class="go">  &quot;configs&quot;: [</span>
<span class="go">    {</span>
<span class="go">      &quot;created_by&quot;: null,</span>
<span class="go">      &quot;creation_date&quot;: &quot;Tue, 14 May 2019 17:05:43 GMT&quot;,</span>
<span class="go">      &quot;id&quot;: 1,</span>
<span class="go">      &quot;is_active&quot;: true,</span>
<span class="go">      &quot;modification_date&quot;: &quot;Tue, 14 May 2019 17:05:43 GMT&quot;,</span>
<span class="go">      &quot;modified_by&quot;: null,</span>
<span class="go">      &quot;name&quot;: &quot;symphony sales config&quot;,</span>
<span class="go">      &quot;params&quot;: [</span>
<span class="go">        {</span>
<span class="go">          &quot;description&quot;: &quot;Check if all values in column are of float data type&quot;,</span>
<span class="go">          &quot;id&quot;: 1004,</span>
<span class="go">          &quot;name&quot;: &quot;CheckFloatDataType&quot;,</span>
<span class="go">          &quot;parameters&quot;: [</span>
<span class="go">            {</span>
<span class="go">              &quot;param&quot;: &quot;colname&quot;,</span>
<span class="go">              &quot;value&quot;: &quot;NRX_AMOUNT&quot;</span>
<span class="go">            },</span>
<span class="go">            {</span>
<span class="go">              &quot;param&quot;: &quot;tablename&quot;,</span>
<span class="go">              &quot;value&quot;: &quot;s3__121_1212&quot;</span>
<span class="go">            }</span>
<span class="go">          ]</span>
<span class="go">        }</span>
<span class="go">      ],</span>
<span class="go">      &quot;std_object&quot;: &quot;SHS.Retail Sales&quot;,</span>
<span class="go">      &quot;version&quot;: 1</span>
<span class="go">    }</span>
<span class="go">  ]</span>
<span class="go">}</span>
</pre></div>
</div>
</dd></dl>

<dl class="function">
<dt id="controller.config.get">
<code class="sig-prename descclassname">controller.config.</code><code class="sig-name descname">get</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#controller.config.get" title="Permalink to this definition">¶</a></dt>
<dd><p>Retrieve the configuration from the postgres db.</p>
<p>Fetch the configurations from postgres for a given standard object.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>id</strong> (<em>int</em>) – the id of the config to be fetched</p>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>a JSON object with all the filled <code class="docutils literal notranslate"><span class="pre">parameters</span></code>.</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p>dict</p>
</dd>
</dl>
<p class="rubric">Examples</p>
<p>Fetch the specific config using the id.</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="kn">import</span> <span class="nn">requests</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">requests</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;http://localhost:5001/api/config/get?&#39;</span>
<span class="gp">... </span>             <span class="s1">&#39;id=1&#39;</span><span class="p">)</span>
<span class="go">{</span>
<span class="go">  &quot;config&quot;: [</span>
<span class="go">    {</span>
<span class="go">      &quot;created_by&quot;: null,</span>
<span class="go">      &quot;creation_date&quot;: &quot;Tue, 14 May 2019 17:05:43 GMT&quot;,</span>
<span class="go">      &quot;id&quot;: 1,</span>
<span class="go">      &quot;is_active&quot;: true,</span>
<span class="go">      &quot;modification_date&quot;: &quot;Tue, 14 May 2019 17:05:43 GMT&quot;,</span>
<span class="go">      &quot;modified_by&quot;: null,</span>
<span class="go">      &quot;name&quot;: &quot;symphony sales config&quot;,</span>
<span class="go">      &quot;params&quot;: [</span>
<span class="go">        {</span>
<span class="go">          &quot;description&quot;: &quot;Check if all values in column are of float data type&quot;,</span>
<span class="go">          &quot;id&quot;: 1004,</span>
<span class="go">          &quot;name&quot;: &quot;CheckFloatDataType&quot;,</span>
<span class="go">          &quot;parameters&quot;: [</span>
<span class="go">            {</span>
<span class="go">              &quot;param&quot;: &quot;colname&quot;,</span>
<span class="go">              &quot;value&quot;: &quot;NRX_AMOUNT&quot;</span>
<span class="go">            },</span>
<span class="go">            {</span>
<span class="go">              &quot;param&quot;: &quot;tablename&quot;,</span>
<span class="go">              &quot;value&quot;: &quot;s3__121_1212&quot;</span>
<span class="go">            }</span>
<span class="go">          ]</span>
<span class="go">        }</span>
<span class="go">      ],</span>
<span class="go">      &quot;std_object&quot;: &quot;SHS.Retail Sales&quot;,</span>
<span class="go">      &quot;version&quot;: 1</span>
<span class="go">    }</span>
<span class="go">  ]</span>
<span class="go">}</span>
</pre></div>
</div>
</dd></dl>

<dl class="function">
<dt id="controller.config.build">
<code class="sig-prename descclassname">controller.config.</code><code class="sig-name descname">build</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#controller.config.build" title="Permalink to this definition">¶</a></dt>
<dd><p>Build the data type based configuration rules by reading rules from postgres db.</p>
<p>Depending upon the type of columns provided by the <cite>request</cite> the configuration containing the <cite>dtype</cite>
checks is built at run-time. The sample input of the shape is as follows:
[{“name”: “col1”, “dtype”: “numeric”}, {“name”: “col2”, “dtype”: “varchar”},
{“name”: “col3”, “dtype”:”date”, “format”: “YYYY-MM-DD”}]</p>
<p>Using this shape, the automated rules are generated which will run the system based validation
to consume the data into redshift table with exact dtypes.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>shape</strong> (<em>JSON</em>) – a collection with both column name and its dtype</p>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>a JSON object with all the filled <code class="docutils literal notranslate"><span class="pre">parameters</span></code>.</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p>dict</p>
</dd>
</dl>
<p class="rubric">Examples</p>
<p>Fetch the specific config using the id.</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="kn">import</span> <span class="nn">requests</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">requests</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;http://localhost:5001/api/config/build?&#39;</span>
<span class="gp">... </span>             <span class="s1">&#39;shape=[{&quot;name&quot;: &quot;col_1&quot;, &quot;dtype&quot;: &quot;numeric&quot;}, &#39;</span>
<span class="gp">... </span>             <span class="s1">&#39;{&quot;name&quot;: &quot;col2&quot;, &quot;dtype&quot;: &quot;varchar}, {&quot;name&quot;:&quot;col3&quot;, &quot;dtype&quot;: &quot;date&quot;,&#39;</span>
<span class="gp">... </span>             <span class="s1">&#39;&quot;format&quot;: &quot;YYYY-MM-DD&quot;}]&#39;</span><span class="p">)</span>
<span class="go">{</span>
<span class="go">  &quot;config&quot;: [</span>
<span class="go">    {</span>
<span class="go">      &quot;created_by&quot;: null,</span>
<span class="go">      &quot;creation_date&quot;: &quot;Tue, 14 May 2019 17:05:43 GMT&quot;,</span>
<span class="go">      &quot;id&quot;: 1,</span>
<span class="go">      &quot;is_active&quot;: true,</span>
<span class="go">      &quot;modification_date&quot;: &quot;Tue, 14 May 2019 17:05:43 GMT&quot;,</span>
<span class="go">      &quot;modified_by&quot;: null,</span>
<span class="go">      &quot;name&quot;: &quot;symphony sales config&quot;,</span>
<span class="go">      &quot;params&quot;: [</span>
<span class="go">        {</span>
<span class="go">          &quot;description&quot;: &quot;Check if all values in column are of float data type&quot;,</span>
<span class="go">          &quot;id&quot;: 1004,</span>
<span class="go">          &quot;name&quot;: &quot;CheckFloatDataType&quot;,</span>
<span class="go">          &quot;parameters&quot;: [</span>
<span class="go">            {</span>
<span class="go">              &quot;param&quot;: &quot;colname&quot;,</span>
<span class="go">              &quot;value&quot;: &quot;NRX_AMOUNT&quot;</span>
<span class="go">            },</span>
<span class="go">            {</span>
<span class="go">              &quot;param&quot;: &quot;tablename&quot;,</span>
<span class="go">              &quot;value&quot;: &quot;s3__121_1212&quot;</span>
<span class="go">            }</span>
<span class="go">          ]</span>
<span class="go">        }</span>
<span class="go">      ],</span>
<span class="go">      &quot;std_object&quot;: &quot;SHS.Retail Sales&quot;,</span>
<span class="go">      &quot;version&quot;: 1</span>
<span class="go">    }</span>
<span class="go">  ]</span>
<span class="go">}</span>
</pre></div>
</div>
</dd></dl>

<dl class="function">
<dt id="controller.config.update">
<code class="sig-prename descclassname">controller.config.</code><code class="sig-name descname">update</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#controller.config.update" title="Permalink to this definition">¶</a></dt>
<dd><p>Update the configuration into the postgres db for a given file.</p>
<p>Save the configuration in <code class="docutils literal notranslate"><span class="pre">config</span></code> table of the postgres db and generate a unique ID which will be used by
other services to retrieve the configuration required to run the validation. The API support both GET and POST
protocol.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><ul class="simple">
<li><p><strong>file_id</strong> (<em>int</em>) – file id</p></li>
<li><p><strong>connector_id</strong> (<em>int</em>) – connector id of the resource.</p></li>
<li><p><strong>name</strong> (<em>string</em>) – Identifier for the unique configuration which share different versions</p></li>
<li><p><strong>std_object</strong> (<em>string</em>) – [Optional] mapping of the current config to any specific standard object</p></li>
<li><p><strong>user_defined</strong> (<em>JSON</em>) – [Optional] the configuration required to run the validations.</p></li>
<li><p><strong>system_defined</strong> (<em>JSON</em>) – [Optional] these include the data type checks.</p></li>
</ul>
</dd>
<dt class="field-even">Returns</dt>
<dd class="field-even"><p>a JSON object which has the <code class="docutils literal notranslate"><span class="pre">config_id</span></code> generated for the given configuration.</p>
</dd>
<dt class="field-odd">Return type</dt>
<dd class="field-odd"><p>dict</p>
</dd>
</dl>
<p class="rubric">Examples</p>
<p>Add configuration against the standard object.</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="kn">import</span> <span class="nn">requests</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">requests</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;http://localhost:5001/api/config/update?id=99&amp;user_defined=&#39;</span>
<span class="gp">... </span>             <span class="s1">&#39;[{ &quot;parameters&quot;: [ { &quot;param&quot;: &quot;colname&quot;, &quot;value&quot;: &quot;NRX_AMOUNT&quot; }, { &quot;param&quot;:&#39;</span>
<span class="gp">... </span>             <span class="s1">&#39;&quot;tablename&quot;, &quot;value&quot;: &quot;s3__121_1212&quot; } ], &quot;description&quot;: &quot;Check if all values in&#39;</span>
<span class="gp">... </span>             <span class="s1">&#39;column are of float data type&quot;, &quot;id&quot;: 1004, &quot;name&quot;: &quot;CheckFloatDataType&quot; }]&amp;&#39;</span>
<span class="gp">... </span>             <span class="s1">&#39;std_object=unknown&amp;name=dummy retail sales&amp;file_id=2&amp;version=1&amp;connector_id=1&#39;</span><span class="p">)</span>
<span class="go">{</span>
<span class="go">    &quot;config&quot;: [</span>
<span class="go">        {</span>
<span class="go">            &quot;created_by&quot;: null,</span>
<span class="go">            &quot;creation_date&quot;: &quot;Mon, 27 May 2019 09:46:12 GMT&quot;,</span>
<span class="go">            &quot;id&quot;: 27,</span>
<span class="go">            &quot;is_active&quot;: true,</span>
<span class="go">            &quot;modification_date&quot;: &quot;Mon, 27 May 2019 09:46:12 GMT&quot;,</span>
<span class="go">            &quot;modified_by&quot;: null,</span>
<span class="go">            &quot;name&quot;: &quot;dummy retail sales&quot;,</span>
<span class="go">            &quot;params&quot;: [</span>
<span class="go">                {</span>
<span class="go">                    &quot;datatype&quot;: &quot;varchar&quot;,</span>
<span class="go">                    &quot;id&quot;: 1009,</span>
<span class="go">                    &quot;name&quot;: &quot;CheckColumnLength&quot;,</span>
<span class="go">                    &quot;parameters&quot;: [</span>
<span class="go">                        {</span>
<span class="go">                            &quot;param&quot;: &quot;tablename&quot;,</span>
<span class="go">                            &quot;value&quot;: &quot;s3_e8f3658a7d6c40eeb2efc2076d969d3a&quot;</span>
<span class="go">                        },</span>
<span class="go">                        {</span>
<span class="go">                            &quot;datatype&quot;: &quot;varchar&quot;,</span>
<span class="go">                            &quot;param&quot;: &quot;colname&quot;,</span>
<span class="go">                            &quot;type&quot;: &quot;column&quot;,</span>
<span class="go">                            &quot;value&quot;: &quot;market_id&quot;</span>
<span class="go">                        },</span>
<span class="go">                        {</span>
<span class="go">                            &quot;param&quot;: &quot;operator&quot;,</span>
<span class="go">                            &quot;value&quot;: &quot;=&quot;</span>
<span class="go">                        },</span>
<span class="go">                        {</span>
<span class="go">                            &quot;param&quot;: &quot;thresholdval&quot;,</span>
<span class="go">                            &quot;value&quot;: &quot;6&quot;</span>
<span class="go">                        },</span>
<span class="go">                        {</span>
<span class="go">                            &quot;param&quot;: &quot;schema&quot;,</span>
<span class="go">                            &quot;type&quot;: &quot;schema&quot;,</span>
<span class="go">                            &quot;value&quot;: &quot;source&quot;</span>
<span class="go">                        }</span>
<span class="go">                    ]</span>
<span class="go">                },</span>
<span class="go">                {</span>
<span class="go">                    ...</span>
<span class="go">                }</span>
<span class="go">            ],</span>
<span class="go">            &quot;std_object&quot;: &quot;unknown&quot;,</span>
<span class="go">            &quot;version&quot;: 2</span>
<span class="go">        }</span>
<span class="go">    ]</span>
<span class="go">}</span>
</pre></div>
</div>
</dd></dl>

<dl class="function">
<dt id="controller.config.delete">
<code class="sig-prename descclassname">controller.config.</code><code class="sig-name descname">delete</code><span class="sig-paren">(</span><span class="sig-paren">)</span><a class="headerlink" href="#controller.config.delete" title="Permalink to this definition">¶</a></dt>
<dd><p>Delete the configuration from the postgres db.</p>
<dl class="field-list simple">
<dt class="field-odd">Parameters</dt>
<dd class="field-odd"><p><strong>config_id</strong> (<em>int</em>) – id of the configuration.</p>
</dd>
</dl>
<p class="rubric">Examples</p>
<p>Delete the configuration from the system using the API call.</p>
<div class="doctest highlight-default notranslate"><div class="highlight"><pre><span></span><span class="gp">&gt;&gt;&gt; </span><span class="kn">import</span> <span class="nn">requests</span>
<span class="gp">&gt;&gt;&gt; </span><span class="n">requests</span><span class="o">.</span><span class="n">get</span><span class="p">(</span><span class="s1">&#39;http://localhost:5001/api/config/delete?config_id=12&#39;</span><span class="p">)</span>
<span class="go">{</span>
<span class="go">   &quot;message&quot;: &quot;deleted successfully&quot;</span>
<span class="go">}</span>
</pre></div>
</div>
</dd></dl>

</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <div role="note" aria-label="source link">
    <h3>This Page</h3>
    <ul class="this-page-menu">
      <li><a href="_sources/controller.config.rst.txt"
            rel="nofollow">Show Source</a></li>
    </ul>
   </div>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="Go" />
    </form>
    </div>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="nav-item nav-item-0"><a href="index.html">DataMAx 0.1 documentation</a> &#187;</li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2019, AxtriaOne.
      Created using <a href="http://sphinx-doc.org/">Sphinx</a> 2.3.1.
    </div>
  </body>
</html>